unit PlannerRole;

interface

uses
  Winapi.Windows, Winapi.Messages,
  System.SysUtils, System.Variants, System.Classes, System.Generics.Collections,
  Vcl.Menus, Vcl.ComCtrls, Vcl.ExtCtrls, Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Mask,
  FireDAC.Stan.Intf, FireDAC.Comp.DataSet, FireDAC.Comp.Client,
  Data.DB, Data.Win.ADODB,
  AdvPanel, AdvStyleIF, AdvGlowButton, AdvCombo, AdvAppStyler, AdvOfficePager, AdvGroupBox, AdvOfficeButtons, AdvSpin,
  AdvDropDown, AdvSmoothEdit, AdvSmoothEditButton, AdvSmoothDatePicker,
  Planner, DBPlanner, PlannerMonthView,
  uPlannerRole, FireDAC.Phys,
  FireDAC.Comp.UI, VirtualTrees, FireDAC.Stan.Option, FireDAC.Stan.Param, FireDAC.Stan.Error, FireDAC.DatS,
  FireDAC.Phys.Intf, FireDAC.DApt.Intf, FireDAC.Stan.Async, FireDAC.DApt, FireDAC.UI.Intf, FireDAC.Stan.Def,
  FireDAC.Stan.Pool, FireDAC.Phys.MSAcc, FireDAC.Phys.MSAccDef, FireDAC.VCLUI.Wait;

type
  TViews = (vwMultiDay, vwPeriod, vwHalfDayPeriod, vwMonth, vwMultiMonth, vwTimeLine, vwActiveDay, vwActiveDayPeriod);
  TPage = (pgDay);

  TfrmPlannerRole = class(TForm)
    advcbxViews: TAdvComboBox;
    advgrbDateActiveDayPeriod: TAdvGroupBox;
    advgrbDatePeriod: TAdvGroupBox;
    advgrbDateTimeLine: TAdvGroupBox;
    advgrbOccupiedActiveDay: TAdvGroupBox;
    advgrbOccupiedActiveDayPeriod: TAdvGroupBox;
    advgrbOccupiedHalfDayPeriod: TAdvGroupBox;
    advgrbOccupiedMonth: TAdvGroupBox;
    advgrbOccupiedMultiDay: TAdvGroupBox;
    advgrbOccupiedMultiMonth: TAdvGroupBox;
    advgrbOccupiedPeriod: TAdvGroupBox;
    advgrbOccupiedTimeLine: TAdvGroupBox;
    advgrbPeriodHalfDayPeriod: TAdvGroupBox;
    advpgeDay: TAdvOfficePage;
    advsedDayIncrementMultiDay: TAdvSpinEdit;
    advsedMonthIncrementMultiMonth: TAdvSpinEdit;
    advsedMonthOfMonthMultiMonth: TAdvSpinEdit;
    advsedNumberOfDayActiveDay: TAdvSpinEdit;
    advsedNumberOfDayMultiDay: TAdvSpinEdit;
    advsedYearMonth: TAdvSpinEdit;
    advsedYearMultiMonth: TAdvSpinEdit;
    dbacdyprsrActiveDayPeriod: TDBActiveDayPeriodSource;
    dbacdysrActiveDay: TDBActiveDaySource;
    dbdysrMultiDay: TDBDaySource;
    dbhldyprsrHalfDayPeriod: TDBHalfDayPeriodSource;
    dbmlmnsrMultiMonth: TDBMultiMonthSource;
    dbmnsrMonth: TDBMonthSource;
    dbplDay: TDBPlanner;
    dbprsrPeriod: TDBPeriodSource;
    dbtmlnsrTimeLine: TDBTimeLineSource;
    frmstlrPlannerRole: TAdvFormStyler;
    jstpnlActiveDay: TAdvPanel;
    jstpnlActiveDayPeriod: TAdvPanel;
    jstpnlAdvOfficePager: TAdvPanel;
    jstpnlDayOptionsBasic: TAdvPanel;
    jstpnlHalfDayPeriod: TAdvPanel;
    jstpnljstpnlDayOptions: TAdvPanel;
    jstpnlMonth: TAdvPanel;
    jstpnlMultiDay: TAdvPanel;
    jstpnlMultiMonth: TAdvPanel;
    jstpnlPeriod: TAdvPanel;
    jstpnlProperyTop: TAdvPanel;
    jstpnlTimeLine: TAdvPanel;
    lblActiveDay: TLabel;
    lblActiveDayPeriod: TLabel;
    lblHalfDayPeriod: TLabel;
    lblMonth: TLabel;
    lblMultiDay: TLabel;
    lblMultiMonth: TLabel;
    lblPeriod: TLabel;
    lblTimeLine: TLabel;
    offchbInPositionGapActiveDay: TAdvOfficeCheckBox;
    offchbInPositionGapActiveDayPeriod: TAdvOfficeCheckBox;
    offchbInPositionGapHalfDayPeriod: TAdvOfficeCheckBox;
    offchbInPositionGapMonth: TAdvOfficeCheckBox;
    offchbInPositionGapMultiDay: TAdvOfficeCheckBox;
    offchbInPositionGapMultiMonth: TAdvOfficeCheckBox;
    offchbInPositionGapPeriod: TAdvOfficeCheckBox;
    offchbInPositionGapTimeLine: TAdvOfficeCheckBox;
    offchbRepeatSideBarActiveDay: TAdvOfficeCheckBox;
    offchbRepeatSideBarMultiDay: TAdvOfficeCheckBox;
    offchbRepeatSideBarMultiMonth: TAdvOfficeCheckBox;
    offchbShowOccupiedActiveDay: TAdvOfficeCheckBox;
    offchbShowOccupiedActiveDayPeriod: TAdvOfficeCheckBox;
    offchbShowOccupiedHalfDayPeriod: TAdvOfficeCheckBox;
    offchbShowOccupiedMonth: TAdvOfficeCheckBox;
    offchbShowOccupiedMultiDay: TAdvOfficeCheckBox;
    offchbShowOccupiedMultiMonth: TAdvOfficeCheckBox;
    offchbShowOccupiedPeriod: TAdvOfficeCheckBox;
    offchbShowOccupiedTimeLine: TAdvOfficeCheckBox;
    offpgrPlanner: TAdvOfficePager;
    offrgrSideBarPositionActiveDay: TAdvOfficeRadioGroup;
    offrgrSideBarPositionActiveDayPeriod: TAdvOfficeRadioGroup;
    offrgrSideBarPositionHalfDayPeriod: TAdvOfficeRadioGroup;
    offrgrSideBarPositionMonth: TAdvOfficeRadioGroup;
    offrgrSideBarPositionMultiDay: TAdvOfficeRadioGroup;
    offrgrSideBarPositionMultiMonth: TAdvOfficeRadioGroup;
    offrgrSideBarPositionPeriod: TAdvOfficeRadioGroup;
    offrgrSideBarPositionTimeLine: TAdvOfficeRadioGroup;
    smdtpkDayActiveDay: TAdvSmoothDatePicker;
    smdtpkDayMultiDay: TAdvSmoothDatePicker;
    smdtpkFromActiveDayPeriod: TAdvSmoothDatePicker;
    smdtpkFromHalfDayPeriod: TAdvSmoothDatePicker;
    smdtpkFromPeriod: TAdvSmoothDatePicker;
    smdtpkFromTimeLine: TAdvSmoothDatePicker;
    smdtpkToActiveDayPeriod: TAdvSmoothDatePicker;
    smdtpkToHalfDayPeriod: TAdvSmoothDatePicker;
    smdtpkToPeriod: TAdvSmoothDatePicker;
    smdtpkToTimeLine: TAdvSmoothDatePicker;
    jstpnlDisplayActiveDay: TAdvPanel;
    advgrbDisplayActiveDay: TAdvGroupBox;
    lblDispalyActiveDay: TLabel;
    lblDisplayStartActiveDay: TLabel;
    lblDisplayEndActiveDay: TLabel;
    lblActiveActiveDay: TLabel;
    jstpnlDisplayMultiDay: TAdvPanel;
    advgrbDisplayMultiDay: TAdvGroupBox;
    lblDisplayMultiDay: TLabel;
    lblDisplayStartMultiDay: TLabel;
    lblDisplayEndMultiDay: TLabel;
    lblActiveMultiDay: TLabel;
    jstpnlTimeLineTimeLine: TAdvPanel;
    advgrbDisplayTimeLine: TAdvGroupBox;
    lblDisplayTimeLine: TLabel;
    lblDisplayStartTimeLine: TLabel;
    lblDisplayEndTimeLine: TLabel;
    lblActiveTimeLine: TLabel;
    advcbxStartMonthMultiMonth: TAdvComboBox;
    advcbxMonthMonth: TAdvComboBox;
    glwbtnDatePeriod: TAdvGlowButton;
    glwbtnPeriodHalfDayPeriod: TAdvGlowButton;
    glwbtnDateActiveDayPeriod: TAdvGlowButton;
    glwbtnDateTimeLine: TAdvGlowButton;
    dsMultiDay: TDataSource;
    dsPeriod: TDataSource;
    dsHalfDayPeriod: TDataSource;
    dsMonth: TDataSource;
    dsMultiMonth: TDataSource;
    dsTimeLine: TDataSource;
    dsActiveDay: TDataSource;
    dsActiveDayPeriod: TDataSource;
    fdqryActiveDayPeriod: TFDQuery;
    fdqryActiveDay: TFDQuery;
    fdqryTimeLine: TFDQuery;
    fdqryMultiMonth: TFDQuery;
    fdqryMonth: TFDQuery;
    fdqryHalfDayPeriod: TFDQuery;
    fdqryPeriod: TFDQuery;
    fdqryMultiDay: TFDQuery;
    conAccess: TFDConnection;
    fdtrReadOnlyTransaction: TFDTransaction;
    fdtrReadWriteTransaction: TFDTransaction;
    fdgxwtcrsr1: TFDGUIxWaitCursor;
    fdtncfldMultiDayIDSCHEDULE: TFDAutoIncField;
    sqltmstmpfldMultiDaySTARTTIME: TSQLTimeStampField;
    sqltmstmpfldMultiDayENDTIME: TSQLTimeStampField;
    wdstrngfldMultiDaySUBJECT: TWideStringField;
    wdstrngfldMultiDayNOTES: TWideStringField;
    intgrfldMultiDayCOLOR: TIntegerField;
    intgrfldMultiDayIMAGE: TIntegerField;
    blnfldMultiDayCAPTION: TBooleanField;
    intgrfldMultiDayRESOURCE: TIntegerField;
    wdstrngfldMultiDayRECURRENCY: TWideStringField;
    sqltmstmpfldMultiDayMINTIME: TSQLTimeStampField;
    sqltmstmpfldMultiDayMAXTIME: TSQLTimeStampField;
    intgrfldMultiDaySHAPE: TIntegerField;
    fdtncfldPeriodIDSCHEDULE: TFDAutoIncField;
    sqltmstmpfldPeriodSTARTTIME: TSQLTimeStampField;
    sqltmstmpfldPeriodENDTIME: TSQLTimeStampField;
    wdstrngfldPeriodSUBJECT: TWideStringField;
    wdstrngfldPeriodNOTES: TWideStringField;
    intgrfldPeriodCOLOR: TIntegerField;
    intgrfldPeriodIMAGE: TIntegerField;
    blnfldPeriodCAPTION: TBooleanField;
    intgrfldPeriodRESOURCE: TIntegerField;
    wdstrngfldPeriodRECURRENCY: TWideStringField;
    sqltmstmpfldPeriodMINTIME: TSQLTimeStampField;
    sqltmstmpfldPeriodMAXTIME: TSQLTimeStampField;
    intgrfldPeriodSHAPE: TIntegerField;
    fdtncfldHalfDayPeriodIDSCHEDULE: TFDAutoIncField;
    sqltmstmpfldHalfDayPeriodSTARTTIME: TSQLTimeStampField;
    sqltmstmpfldHalfDayPeriodENDTIME: TSQLTimeStampField;
    wdstrngfldHalfDayPeriodSUBJECT: TWideStringField;
    wdstrngfldHalfDayPeriodNOTES: TWideStringField;
    intgrfldHalfDayPeriodCOLOR: TIntegerField;
    intgrfldHalfDayPeriodIMAGE: TIntegerField;
    blnfldHalfDayPeriodCAPTION: TBooleanField;
    intgrfldHalfDayPeriodRESOURCE: TIntegerField;
    wdstrngfldHalfDayPeriodRECURRENCY: TWideStringField;
    sqltmstmpfldHalfDayPeriodMINTIME: TSQLTimeStampField;
    sqltmstmpfldHalfDayPeriodMAXTIME: TSQLTimeStampField;
    intgrfldHalfDayPeriodSHAPE: TIntegerField;
    fdtncfldMonthIDSCHEDULE: TFDAutoIncField;
    sqltmstmpfldMonthSTARTTIME: TSQLTimeStampField;
    sqltmstmpfldMonthENDTIME: TSQLTimeStampField;
    wdstrngfldMonthSUBJECT: TWideStringField;
    wdstrngfldMonthNOTES: TWideStringField;
    intgrfldMonthCOLOR: TIntegerField;
    intgrfldMonthIMAGE: TIntegerField;
    blnfldMonthCAPTION: TBooleanField;
    intgrfldMonthRESOURCE: TIntegerField;
    wdstrngfldMonthRECURRENCY: TWideStringField;
    sqltmstmpfldMonthMINTIME: TSQLTimeStampField;
    sqltmstmpfldMonthMAXTIME: TSQLTimeStampField;
    intgrfldMonthSHAPE: TIntegerField;
    fdtncfldMultiMonthIDSCHEDULE: TFDAutoIncField;
    sqltmstmpfldMultiMonthSTARTTIME: TSQLTimeStampField;
    sqltmstmpfldMultiMonthENDTIME: TSQLTimeStampField;
    wdstrngfldMultiMonthSUBJECT: TWideStringField;
    wdstrngfldMultiMonthNOTES: TWideStringField;
    intgrfldMultiMonthCOLOR: TIntegerField;
    intgrfldMultiMonthIMAGE: TIntegerField;
    blnfldMultiMonthCAPTION: TBooleanField;
    intgrfldMultiMonthRESOURCE: TIntegerField;
    wdstrngfldMultiMonthRECURRENCY: TWideStringField;
    sqltmstmpfldMultiMonthMINTIME: TSQLTimeStampField;
    sqltmstmpfldMultiMonthMAXTIME: TSQLTimeStampField;
    intgrfldMultiMonthSHAPE: TIntegerField;
    fdtncfldTimeLineIDSCHEDULE: TFDAutoIncField;
    sqltmstmpfldTimeLineSTARTTIME: TSQLTimeStampField;
    sqltmstmpfldTimeLineENDTIME: TSQLTimeStampField;
    wdstrngfldTimeLineSUBJECT: TWideStringField;
    wdstrngfldTimeLineNOTES: TWideStringField;
    intgrfldTimeLineCOLOR: TIntegerField;
    intgrfldTimeLineIMAGE: TIntegerField;
    blnfldTimeLineCAPTION: TBooleanField;
    intgrfldTimeLineRESOURCE: TIntegerField;
    wdstrngfldTimeLineRECURRENCY: TWideStringField;
    sqltmstmpfldTimeLineMINTIME: TSQLTimeStampField;
    sqltmstmpfldTimeLineMAXTIME: TSQLTimeStampField;
    intgrfldTimeLineSHAPE: TIntegerField;
    fdtncfldActiveDayIDSCHEDULE: TFDAutoIncField;
    sqltmstmpfldActiveDaySTARTTIME: TSQLTimeStampField;
    sqltmstmpfldActiveDayENDTIME: TSQLTimeStampField;
    wdstrngfldActiveDaySUBJECT: TWideStringField;
    wdstrngfldActiveDayNOTES: TWideStringField;
    intgrfldActiveDayCOLOR: TIntegerField;
    intgrfldActiveDayIMAGE: TIntegerField;
    blnfldActiveDayCAPTION: TBooleanField;
    intgrfldActiveDayRESOURCE: TIntegerField;
    wdstrngfldActiveDayRECURRENCY: TWideStringField;
    sqltmstmpfldActiveDayMINTIME: TSQLTimeStampField;
    sqltmstmpfldActiveDayMAXTIME: TSQLTimeStampField;
    intgrfldActiveDaySHAPE: TIntegerField;
    fdtncfldActiveDayPeriodIDSCHEDULE: TFDAutoIncField;
    sqltmstmpfldActiveDayPeriodSTARTTIME: TSQLTimeStampField;
    sqltmstmpfldActiveDayPeriodENDTIME: TSQLTimeStampField;
    wdstrngfldActiveDayPeriodSUBJECT: TWideStringField;
    wdstrngfldActiveDayPeriodNOTES: TWideStringField;
    intgrfldActiveDayPeriodCOLOR: TIntegerField;
    intgrfldActiveDayPeriodIMAGE: TIntegerField;
    blnfldActiveDayPeriodCAPTION: TBooleanField;
    intgrfldActiveDayPeriodRESOURCE: TIntegerField;
    wdstrngfldActiveDayPeriodRECURRENCY: TWideStringField;
    sqltmstmpfldActiveDayPeriodMINTIME: TSQLTimeStampField;
    sqltmstmpfldActiveDayPeriodMAXTIME: TSQLTimeStampField;
    intgrfldActiveDayPeriodSHAPE: TIntegerField;
    pnlTimes: TPanel;
    dtpDisplayStartMultiDay: TDateTimePicker;
    dtpDisplayEndMultiDay: TDateTimePicker;
    dtpActiveStartMultiDay: TDateTimePicker;
    dtpActiveEndMultiDay: TDateTimePicker;
    pnl1: TPanel;
    dtpDisplayStartActiveDay: TDateTimePicker;
    dtpDisplayEndActiveDay: TDateTimePicker;
    dtpActiveStartActiveDay: TDateTimePicker;
    dtpActiveEndActiveDay: TDateTimePicker;
    pnl2: TPanel;
    dtpDisplayStartTimeLine: TDateTimePicker;
    dtpDisplayEndTimeLine: TDateTimePicker;
    dtpActiveStartTimeLine: TDateTimePicker;
    dtpActiveEndTimeLine: TDateTimePicker;
    advsedNumberOfResourceActiveDayPeriod: TAdvSpinEdit;
    advsedRowHeightActiveDayPeriod: TAdvSpinEdit;
    advsedColumnWidthActiveDayPeriod: TAdvSpinEdit;
    advsedSideBarWidthActiveDayPeriod: TAdvSpinEdit;
    advsedHeaderHeightActiveDayPeriod: TAdvSpinEdit;
    advsedRowHeightActiveDay: TAdvSpinEdit;
    advsedColumnWidthActiveDay: TAdvSpinEdit;
    advsedSideBarWidthActiveDay: TAdvSpinEdit;
    advsedHeaderHeightActiveDay: TAdvSpinEdit;
    advcbxTimeLineActiveDay: TAdvComboBox;
    glwbtnApplyActiveDay: TAdvGlowButton;
    advsedNumberOfResourceActiveDay: TAdvSpinEdit;
    advsedDayIncrementActiveDay: TAdvSpinEdit;
    advsedRowHeightMultiDay: TAdvSpinEdit;
    advsedColumnWidthMultiDay: TAdvSpinEdit;
    advsedSideBarWidthMultiDay: TAdvSpinEdit;
    advsedHeaderHeightMultiDay: TAdvSpinEdit;
    advsedNumberOfResourceMultiDay: TAdvSpinEdit;
    advcbxTimeLineMultiDay: TAdvComboBox;
    glwbtnApplyMultiDay: TAdvGlowButton;
    advsedRowHeightMonth: TAdvSpinEdit;
    advsedColumnWidthMonth: TAdvSpinEdit;
    advsedSideBarWidthMonth: TAdvSpinEdit;
    advsedHeaderHeightMonth: TAdvSpinEdit;
    advsedMonthIncermentMonth: TAdvSpinEdit;
    advsedNumberOfResourceMonth: TAdvSpinEdit;
    advsedRowHeightMultiMonth: TAdvSpinEdit;
    advsedColumnWidthMultiMonth: TAdvSpinEdit;
    advsedSideBarWidthMultiMonth: TAdvSpinEdit;
    advsedHeaderHeightMultiMonth: TAdvSpinEdit;
    advsedRowHeightHalfDayPeriod: TAdvSpinEdit;
    advsedColumnWidthHalfDayPeriod: TAdvSpinEdit;
    advsedSideBarWidthHalfDayPeriod: TAdvSpinEdit;
    advsedHeaderHeightHalfDayPeriod: TAdvSpinEdit;
    advsedNumberOfResourceHalfDayPeriod: TAdvSpinEdit;
    advsedRowHeightPeriod: TAdvSpinEdit;
    advsedColumnWidthPeriod: TAdvSpinEdit;
    advsedSideBarWidthPeriod: TAdvSpinEdit;
    advsedHeaderHeightPeriod: TAdvSpinEdit;
    advsedNumberOfResourcePeriod: TAdvSpinEdit;
    advsedRowHeightTimeLine: TAdvSpinEdit;
    advsedColumnWidthTimeLine: TAdvSpinEdit;
    advsedSideBarWidthTimeLine: TAdvSpinEdit;
    advsedHeaderHeightTimeLine: TAdvSpinEdit;
    advcbxTimeLineTimeLine: TAdvComboBox;
    glwbtnApplyTimeLine: TAdvGlowButton;
    offchbOnlyActive: TAdvOfficeCheckBox;
    advsedNumberOfResourceTimeLine: TAdvSpinEdit;
    procedure FormCreate(Sender: TObject);
    procedure advcbxStartMonthMultiMonthChange(Sender: TObject);
    procedure advcbxViewsChange(Sender: TObject);
    procedure advsedDayIncrementMultiDayChange(Sender: TObject);
    procedure advsedMonthIncrementMultiMonthChange(Sender: TObject);
    procedure advsedNumberOfDayActiveDayChange(Sender: TObject);
    procedure advsedNumberOfResourceMultiDayChange(Sender: TObject);
    procedure advsedRowHeightTimeLineChange(Sender: TObject);
    procedure advsedYearMultiMonthChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure glwbtnDatePeriodClick(Sender: TObject);
    procedure offchbDayShowOccupiedClick(Sender: TObject);
    procedure offchbInPositionGapActiveDayClick(Sender: TObject);
    procedure offchbRepeatSideBarMultiMonthClick(Sender: TObject);
    procedure offrgrSideBarPositionMonthClick(Sender: TObject);
    procedure smdtpkDayActiveDayChange(Sender: TObject);
  strict private
  const
    Shift = 10;
    DisplayEnd = 1;
    ActiveStart = 2;
    ActiveEnd = 3;
    Header = 'Check dates';
    Footer = 'Time line';
  var
    FTimePickers: Tlist<TDateTimePicker>;
    FRolePlanner: TRolePlanner;
    procedure GetDatePickers(const AParent: TWinControl; var ADatePickerFrom, ADatePickerTo: TAdvSmoothDatePicker);
    procedure DeactivateSource;
  strict protected
    procedure SetForm;
  public
    procedure SetDislplayStartEnd(ATag, ADisplayUnit: Integer);
  end;

var
  frmPlannerRole: TfrmPlannerRole;

implementation

{$R *.dfm}

procedure TfrmPlannerRole.FormCreate(Sender: TObject);
begin
  SetForm;
end;

procedure TfrmPlannerRole.advcbxStartMonthMultiMonthChange(Sender: TObject);
var
  ComboBox: TAdvComboBox;
begin
  ComboBox := TAdvComboBox(Sender);

  case TPage(offpgrPlanner.ActivePageIndex) of
    pgDay:
    begin
      case TViews(advcbxViews.ItemIndex) of
        vwMonth: dbmnsrMonth.Month := ComboBox.ItemIndex + 1;
        vwMultiMonth: dbmlmnsrMultiMonth.StartMonth := ComboBox.ItemIndex + 1;
      end;
    end;
  end;
end;

procedure TfrmPlannerRole.FormDestroy(Sender: TObject);
begin
  FreeAndNil(FRolePlanner);
  FreeAndNil(FTimePickers);
end;

procedure TfrmPlannerRole.advcbxViewsChange(Sender: TObject);
begin
  dbplDay.ItemSource.Active := False;
  TDBItemSource(dbplDay.ItemSource).DataSource.DataSet.Active := False;

  try
    case TViews(advcbxViews.ItemIndex) of
      vwMultiDay: dbplDay.ItemSource := dbdysrMultiDay;
      vwPeriod: dbplDay.ItemSource := dbprsrPeriod;
      vwHalfDayPeriod: dbplDay.ItemSource := dbhldyprsrHalfDayPeriod;
      vwMonth: dbplDay.ItemSource := dbmnsrMonth;
      vwMultiMonth: dbplDay.ItemSource := dbmlmnsrMultiMonth;
      vwTimeLine: dbplDay.ItemSource := dbtmlnsrTimeLine;
      vwActiveDay: dbplDay.ItemSource := dbacdysrActiveDay;
      vwActiveDayPeriod: dbplDay.ItemSource := dbacdyprsrActiveDayPeriod;
    end;

    FRolePlanner.SetPlannerProperies;
  finally
    TDBItemSource(dbplDay.ItemSource).DataSource.DataSet.Active := True;
    dbplDay.ItemSource.Active := True;
  end;

  if TViews(advcbxViews.ItemIndex) = vwTimeLine then
    glwbtnDateTimeLine.OnClick(glwbtnDateTimeLine);
end;

procedure TfrmPlannerRole.advsedDayIncrementMultiDayChange(Sender: TObject);
var
  SpinEdit: TAdvSpinEdit;
begin
  SpinEdit := TAdvSpinEdit(Sender);
  dbdysrMultiDay.DayIncrement := SpinEdit.Value;
end;

procedure TfrmPlannerRole.advsedMonthIncrementMultiMonthChange(Sender: TObject);
var
  SpinEdit: TAdvSpinEdit;
begin
  SpinEdit := TAdvSpinEdit(Sender);
  dbmlmnsrMultiMonth.MonthIncrement := SpinEdit.Value;
end;

procedure TfrmPlannerRole.advsedNumberOfDayActiveDayChange(Sender: TObject);
var
  SpinEdit: TAdvSpinEdit;
begin
  SpinEdit := TAdvSpinEdit(Sender);

  case TViews(advcbxViews.ItemIndex) of
    vwMultiDay: dbdysrMultiDay.NumberOfDays := SpinEdit.Value;
    vwActiveDay: dbacdysrActiveDay.NumberOfDays := SpinEdit.Value;
  end;
end;

procedure TfrmPlannerRole.advsedNumberOfResourceMultiDayChange(Sender: TObject);
var
  SpinEdit: TAdvSpinEdit;
begin
  SpinEdit := TAdvSpinEdit(Sender);

  case TPage(offpgrPlanner.ActivePageIndex) of
    pgDay:
      case TViews(advcbxViews.ItemIndex) of
        vwMultiDay: dbdysrMultiDay.NumberOfResources := SpinEdit.Value;
        vwPeriod: dbprsrPeriod.NumberOfResources := SpinEdit.Value;
        vwHalfDayPeriod: dbhldyprsrHalfDayPeriod.NumberOfResources := SpinEdit.Value;
        vwMonth: dbmnsrMonth.NumberOfResources := SpinEdit.Value;
        vwTimeLine: dbtmlnsrTimeLine.NumberOfResources := SpinEdit.Value;
        vwActiveDay: dbacdysrActiveDay.NumberOfResources := SpinEdit.Value;
        vwActiveDayPeriod: dbacdyprsrActiveDayPeriod.NumberOfResources := SpinEdit.Value;
      end;
  end;
end;

procedure TfrmPlannerRole.advsedRowHeightTimeLineChange(Sender: TObject);
var
  SpinEdit: TAdvSpinEdit;
begin
  SpinEdit := TAdvSpinEdit(Sender);
  dbplDay.Display.Displayscale := SpinEdit.Value;

  case TPage(offpgrPlanner.ActivePageIndex) of
    pgDay: dbplDay.Display.Displayscale := SpinEdit.Value;
  end;
end;

procedure TfrmPlannerRole.advsedYearMultiMonthChange(Sender: TObject);
var
  SpinEdit: TAdvSpinEdit;
begin
  SpinEdit := TAdvSpinEdit(Sender);

  case TViews(advcbxViews.ItemIndex) of
    vwMonth: dbmnsrMonth.Year := SpinEdit.Value;
    vwMultiMonth: dbmlmnsrMultiMonth.Year := SpinEdit.Value;
  end;
end;

procedure TfrmPlannerRole.DeactivateSource;
begin
  fdqryMultiDay.Active := False;
  fdqryPeriod.Active := False;
  fdqryHalfDayPeriod.Active := False;
  fdqryMonth.Active := False;
  fdqryMultiMonth.Active := False;
  fdqryTimeLine.Active := False;
  fdqryActiveDay.Active := False;

  dbdysrMultiDay.Active := False;
  dbprsrPeriod.Active := False;
  dbhldyprsrHalfDayPeriod.Active := False;
  dbmnsrMonth.Active := False;
  dbmlmnsrMultiMonth.Active := False;
  dbtmlnsrTimeLine.Active := False;
  dbacdysrActiveDay.Active := False;
  dbacdyprsrActiveDayPeriod.Active := False;
end;

procedure TfrmPlannerRole.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmPlannerRole.GetDatePickers(const AParent: TWinControl; var ADatePickerFrom, ADatePickerTo:
    TAdvSmoothDatePicker);
var
  I: Integer;
begin
  ADatePickerFrom := nil;
  ADatePickerTo := nil;

  for I := 0 to AParent.ControlCount - 1 do
  begin
    if AParent.Controls[I] is TAdvSmoothDatePicker then
    begin
      if TAdvSmoothDatePicker(AParent.Controls[I]).Tag = 1 then
        ADatePickerFrom := TAdvSmoothDatePicker(AParent.Controls[I])
      else
        ADatePickerTo := TAdvSmoothDatePicker(AParent.Controls[I]);
    end;
  end;
end;

procedure TfrmPlannerRole.offchbDayShowOccupiedClick(Sender: TObject);
var
  CheckBox: TAdvOfficeCheckBox;
begin
  CheckBox := TAdvOfficeCheckBox(Sender);

  case TPage(offpgrPlanner.ActivePageIndex) of
    pgDay: dbplDay.Display.ShowCurrent := CheckBox.Checked;
  end;
end;

procedure TfrmPlannerRole.offchbInPositionGapActiveDayClick(Sender: TObject);
var
  CheckBox: TAdvOfficeCheckBox;
begin
  CheckBox := TAdvOfficeCheckBox(Sender);

  case TPage(offpgrPlanner.ActivePageIndex) of
    pgDay: dbplDay.ShowOccupiedInPositionGap := CheckBox.Checked;
  end;
end;

procedure TfrmPlannerRole.offchbRepeatSideBarMultiMonthClick(Sender: TObject);
var
  CheckBox: TAdvOfficeCheckBox;
begin
  CheckBox := TAdvOfficeCheckBox(Sender);
  FRolePlanner.RepeatSideBar(CheckBox.Checked);
end;

procedure TfrmPlannerRole.offrgrSideBarPositionMonthClick(Sender: TObject);
var
  RadioGroup: TAdvOfficeRadioGroup;
begin
  RadioGroup := TAdvOfficeRadioGroup(Sender);

  case TPage(offpgrPlanner.ActivePageIndex) of
    pgDay: dbplDay.Sidebar.Position := TSideBarPosition(RadioGroup.ItemIndex);
  end;
end;

procedure TfrmPlannerRole.SetDislplayStartEnd(ATag, ADisplayUnit: Integer);
var
  RowsPerH, DispStrH, EndH, ActStrH, DispStrM, EndM, ActStrM: Integer;
  Dsp: TPlannerDisplay;
begin
  dbplDay.ItemSource.BeginUpdate;
  Dsp := dbplDay.Display;

  try
    RowsPerH := (MinsPerHour div ADisplayUnit);
    DispStrH := 6; // HourOf(FTimePickers[ATag].Time);
    DispStrM := 30; // MinuteOf(FTimePickers[ATag].Time);

    Dsp.DisplayUnit := ADisplayUnit;
 { TODO : AV - why? }
    Dsp.DisplayStart := Round(DispStrH + (DispStrM / MinsPerHour)) * RowsPerH;
    EndM := 20; // MinuteOf(FTimePickers[ATag + DisplayEnd].Time);
    EndH := 30; // HourOf(FTimePickers[ATag + DisplayEnd].Time);
    Dsp.DisplayEnd := Round((EndH + (EndM / MinsPerHour)) * RowsPerH) - 1;

    ActStrH := 8; // HourOf(FTimePickers[ATag + ActiveStart].Time);
    ActStrM := 30; // MinuteOf(FTimePickers[ATag + ActiveStart].Time);
    Dsp.ActiveStart := Round(((ActStrH + (ActStrM / MinsPerHour)) - (DispStrH + (DispStrM / MinsPerHour))) * RowsPerH);

    EndH :=  21; //HourOf(FTimePickers[ATag + ActiveEnd].Time);
    EndM :=  30; //MinuteOf(FTimePickers[ATag + ActiveEnd].Time);
    Dsp.ActiveEnd := Round((EndH + (EndM / MinsPerHour)) - (DispStrH + (DispStrM / MinsPerHour))) * RowsPerH;
  finally
    dbplDay.Update;
    dbplDay.ItemSource.EndUpdate;
  end;
end;

procedure TfrmPlannerRole.SetForm;
begin
  DeactivateSource;
  {$IFNDEF DEBUG}
  HideLabel;
  {$ENDIF}
  FRolePlanner := TRolePlanner.Create;
  inherited;
  dbplDay.ItemSource := dbdysrMultiDay;
  advcbxViews.OnChange(advcbxViews);
end;

procedure TfrmPlannerRole.glwbtnDatePeriodClick(Sender: TObject);
var
  ADatePickerFrom, ADatePickerTo: TAdvSmoothDatePicker;
begin
  GetDatePickers(TAdvGlowButton(Sender).Parent, ADatePickerFrom, ADatePickerTo);

  if ADatePickerFrom.Date > ADatePickerTo.Date then
  begin
    ADatePickerTo.SetFocus;
    Exit;
  end;

  case TViews(advcbxViews.ItemIndex) of
    vwPeriod:
    begin
      dbprsrPeriod.StartDate := ADatePickerFrom.Date;
      dbprsrPeriod.EndDate := ADatePickerTo.Date;
    end;
    vwHalfDayPeriod:
    begin
      dbhldyprsrHalfDayPeriod.StartDate := ADatePickerFrom.Date;
      dbhldyprsrHalfDayPeriod.EndDate := ADatePickerTo.Date;
    end;
    vwTimeLine:
    begin
        dbtmlnsrTimeLine.StartDate := ADatePickerFrom.Date;
        dbtmlnsrTimeLine.EndDate := ADatePickerTo.Date;
    end;
    vwActiveDayPeriod:
    begin
      dbacdyprsrActiveDayPeriod.StartDate := ADatePickerFrom.Date;
      dbacdyprsrActiveDayPeriod.EndDate := ADatePickerTo.Date;
    end;
  end;
end;

procedure TfrmPlannerRole.smdtpkDayActiveDayChange(Sender: TObject);
var
  DatePicker: TAdvSmoothDatePicker;
begin
  DatePicker := TAdvSmoothDatePicker(Sender);

  case TViews(advcbxViews.ItemIndex) of
    vwMultiDay: dbdysrMultiDay.Day := DatePicker.Date;
    vwActiveDay: dbacdysrActiveDay.Day := DatePicker.Date;
    vwActiveDayPeriod: ;
  end;
end;

end.
